;*************************************************************************************
;   Filename:   vector.asm
;   Author:     Thomas Dorn, DT-Systems, www.dt-systems.de
;   Date:       20.05.2006
;
;   Brief: Interrupt routines
;
;*************************************************************************************
;
    NAME        ISR_VECTOR
;
#include    "msp430x12x2_TD.inc"

    EXTERN      TIM_OVH_C       ; function is defined in a exteral file

;    PUBLIC      ISR_DUMMY0      ; Declare sysmol to be exported
;    PUBLIC      ISR_DUMMY1      ; Declare sysmol to be exported
    PUBLIC      ISR_P1_HAN      ; Declare sysmol to be exported
    PUBLIC      ISR_P2_HAN      ; Declare sysmol to be exported
;    PUBLIC      ISR_DUMMY2      ; Declare sysmol to be exported
    PUBLIC      ISR_ADC_HAN     ; Declare sysmol to be exported
    PUBLIC      ISR_TX0_HAN     ; Declare sysmol to be exported
    PUBLIC      ISR_RX0_HAN     ; Declare sysmol to be exported
    PUBLIC      ISR_CCIFG0_HAN     ; Declare sysmol to be exported
    PUBLIC      ISR_TA_HAN     ; Declare sysmol to be exported
    PUBLIC      ISR_WD_HAN      ; Declare sysmol to be exported
;    PUBLIC      ISR_DUMMY3      ; Declare sysmol to be exported
;    PUBLIC      ISR_DUMMY4      ; Declare sysmol to be exported
;    PUBLIC      ISR_DUMMY5      ; Declare sysmol to be exported
    PUBLIC      ISR_NMI_HAN     ; Declare sysmol to be exported
;    PUBLIC      ISR_RST_HAN     ; Declare sysmol to be exported


    RSEG        CODE            ; Code is relocatable/move-able
;
;

ISR_DUMMY0      NOP
            reti

ISR_DUMMY1      NOP
            reti

ISR_P1_HAN      NOP
            reti

ISR_P2_HAN      NOP
            reti

ISR_DUMMY2      NOP
            reti

ISR_ADC_HAN
            reti

ISR_TX0_HAN     NOP
            reti

ISR_RX0_HAN     NOP
            reti

; ----------------------------------------------------------------
; ------- TIMER A IRQ service ------------------------------------
; ----------------------------------------------------------------
;
; ----------------------------------------------------------------
ISR_CCIFG0_HAN  ADD     #10000,&TACCR0  ; next INTRPT   ;    #20971
                ; ...             ; TASK0 starts here
                reti            ;
; ----------------------------------------------------------------
; interrupt sharing
;
ISR_TA_HAN  ADD     &TAIV,PC        ; add vector register
                    reti                    ; TAIV = 0:  no irq
                    jmp     CCIFG1_HAN         ; TAIV = 2:  c/c block 1
                    jmp     CCIFG2_HAN         ; TAIV = 4:  c/c block 2
                    reti                    ; TAIV = 6:  n.a.
                    reti                    ; TAIV = 8:  n.a.

TIM_OVH     jmp     TIM_OVH_C       ; TAIV = 10: timer overflow is a c-function
            reti                    ;

; repeat rate = 16,67ms (17476 = 16,67ms * 2^20Hz)
CCIFG1_HAN  ADD     #10000,&TACCR0      ; reload TACCR0
                                     ;EINT
                                     ; nested irq's
            ; ...                    ; task starts here
            reti                    ; back to "main()"

CCIFG2_HAN
            reti                    ; back to "main()"

; ----------------------------------------------------------------

ISR_WD_HAN  ; mov     WDTPW_W + bWDTCNTCL,&WDTCTL  ; reset watchdog
            reti

ISR_DUMMY3      NOP
            reti

ISR_DUMMY4      NOP
            reti

ISR_DUMMY5      NOP
            reti

ISR_NMI_HAN     NOP
            reti

ISR_RST_HAN     NOP
            reti
;
;
  RSEG  INTVEC          ; relocatable location
;  ORG  INTVEC           ; fixed location
;
    DW  ISR_DUMMY0      ; 0xFFE0
    DW  ISR_DUMMY1      ; 0xFFE2
    DW  ISR_P1_HAN      ; 0xFFE4 Port1 P1.0 to P1.7
    DW  ISR_P2_HAN      ; 0xFFE6 Port2 P2.0 to P2.7
    DW  ISR_DUMMY2      ; 0xFFE8
    DW  ISR_ADC_HAN     ; 0xFFEA ADC10
    DW  ISR_TX0_HAN     ; 0xFFEC USART0 transmit
    DW  ISR_RX0_HAN     ; 0xFFEE USART0 receive
    DW  ISR_TA_HAN      ; 0xFFF0 Timer A CC1-2, TA
    DW  ISR_CCIFG0_HAN  ; 0xFFF2 Timer A CC0
    DW  ISR_WD_HAN      ; 0xFFF4 Watchdog timer
    DW  ISR_DUMMY3      ; 0xFFF6
    DW  ISR_DUMMY4      ; 0xFFF8
    DW  ISR_DUMMY5      ; 0xFFFA
    DW  ISR_NMI_HAN     ; 0xFFFC NMI
;    DW  ISR_RST_HAN     ; 0xFFFE Reset is external, power up
;
  END
; end of interrupt handler
;-------------------------------------------------------------------------------------

